/* InputMethod.c generated by valac 0.56.13, the Vala compiler
 * generated from InputMethod.vala, do not modify */

/*
* 2019-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "keyboard.h"
#include <ibus.h>
#include <gio/gio.h>
#include <glib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>

#define KEYBOARD_TYPE_SOURCE_SETTINGS (keyboard_source_settings_get_type ())
#define KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettings))
#define KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))
#define KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEYBOARD_TYPE_SOURCE_SETTINGS))
#define KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEYBOARD_TYPE_SOURCE_SETTINGS, KeyboardSourceSettingsClass))

typedef struct _KeyboardSourceSettings KeyboardSourceSettings;
typedef struct _KeyboardSourceSettingsClass KeyboardSourceSettingsClass;
enum  {
	KEYBOARD_INPUT_METHOD_PAGE_PAGE_0_PROPERTY,
	KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES
};
static GParamSpec* keyboard_input_method_page_page_properties[KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
typedef struct _Block15Data Block15Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KeyboardInputMethodPagePagePrivate {
	IBusBus* bus;
	GSettings* ibus_panel_settings;
	gboolean selection_changing;
	GList* engines;
	GraniteWidgetsAlertView* spawn_failed_alert;
	GtkListBox* listbox;
	KeyboardSourceSettings* settings;
	GtkMenuButton* remove_button;
	KeyboardInputMethodPageAddEnginesPopover* add_engines_popover;
	GtkStack* stack;
	GtkEntry* entry_test;
};

struct _Block14Data {
	int _ref_count_;
	KeyboardInputMethodPagePage* self;
	gchar* engine_name;
};

struct _Block15Data {
	int _ref_count_;
	KeyboardInputMethodPagePage* self;
	GtkComboBoxText* keyboard_shortcut_combobox;
};

static gint KeyboardInputMethodPagePage_private_offset;
static gpointer keyboard_input_method_page_page_parent_class = NULL;

VALA_EXTERN GType keyboard_source_settings_get_type (void) G_GNUC_CONST ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gchar* keyboard_input_method_page_page_get_keyboard_shortcut (KeyboardInputMethodPagePage* self);
static void keyboard_input_method_page_page_set_keyboard_shortcut (KeyboardInputMethodPagePage* self,
                                                            const gchar* combobox_id);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void keyboard_input_method_page_page_update_engines_list (KeyboardInputMethodPagePage* self);
static void __lambda58_ (KeyboardInputMethodPagePage* self,
                  GtkWidget* listbox_child);
static void ___lambda58__gtk_callback (GtkWidget* widget,
                                gpointer self);
VALA_EXTERN void keyboard_source_settings_reset (KeyboardSourceSettings* self,
                                     KeyboardLayoutType* layout_type,
                                     gboolean signal_changed);
VALA_EXTERN gchar** keyboard_source_settings_get_active_engines (KeyboardSourceSettings* self,
                                                     gint* result_length1);
static gchar* keyboard_input_method_page_page_gettext_engine_longname (KeyboardInputMethodPagePage* self,
                                                                IBusEngineDesc* engine);
VALA_EXTERN gboolean keyboard_source_settings_add_layout (KeyboardSourceSettings* self,
                                              KeyboardInputSource* new_layout);
static void keyboard_input_method_page_page_write_ibus_autostart_file (KeyboardInputMethodPagePage* self,
                                                                gboolean enable);
static void keyboard_input_method_page_page_spawn_ibus_daemon (KeyboardInputMethodPagePage* self);
static void keyboard_input_method_page_page_set_visible_view (KeyboardInputMethodPagePage* self,
                                                       const gchar* error_message);
static gboolean __lambda59_ (KeyboardInputMethodPagePage* self);
static gboolean ___lambda59__gsource_func (gpointer self);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static void keyboard_input_method_page_page_update_entry_test_usable (KeyboardInputMethodPagePage* self);
VALA_EXTERN KeyboardInputSource* keyboard_source_settings_get_active_input_source (KeyboardSourceSettings* self);
static void keyboard_input_method_page_page_update_list_box_selected_row (KeyboardInputMethodPagePage* self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void __lambda60_ (Block14Data* _data14_,
                  GtkWidget* widget);
static void ___lambda60__gtk_callback (GtkWidget* widget,
                                gpointer self);
static GObject * keyboard_input_method_page_page_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
VALA_EXTERN KeyboardSourceSettings* keyboard_source_settings_get_instance (void);
static void _keyboard_input_method_page_page___lambda61_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                                gpointer self);
static void _keyboard_input_method_page_page___lambda62_ (KeyboardInputMethodPagePage* self,
                                                   GtkListBoxRow* row);
VALA_EXTERN void keyboard_source_settings_set_active_engine_name (KeyboardSourceSettings* self,
                                                      const gchar* engine_name);
static void __keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                              GtkListBoxRow* row,
                                                                              gpointer self);
static void _keyboard_input_method_page_page___lambda63_ (KeyboardInputMethodPagePage* self,
                                                   const gchar* name);
static void __keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                                   const gchar* name,
                                                                                   gpointer self);
static void _keyboard_input_method_page_page___lambda64_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda64__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _keyboard_input_method_page_page___lambda65_ (KeyboardInputMethodPagePage* self,
                                                   const gchar* engine);
VALA_EXTERN gboolean keyboard_source_settings_add_active_engine (KeyboardSourceSettings* self,
                                                     const gchar* engine_name);
static void __keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine (KeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                              const gchar* new_engine,
                                                                                                              gpointer self);
static void _keyboard_input_method_page_page___lambda66_ (KeyboardInputMethodPagePage* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void keyboard_source_settings_set_active_engines (KeyboardSourceSettings* self,
                                                  gchar** value,
                                                  gint value_length1);
VALA_EXTERN void keyboard_source_settings_set_active_index (KeyboardSourceSettings* self,
                                                guint value);
static void __keyboard_input_method_page_page___lambda66__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _keyboard_input_method_page_page___lambda67_ (Block15Data* _data15_);
static void __keyboard_input_method_page_page___lambda67__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void _keyboard_input_method_page_page___lambda68_ (KeyboardInputMethodPagePage* self);
static void __keyboard_input_method_page_page___lambda68__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void keyboard_input_method_page_page_finalize (GObject * obj);
static GType keyboard_input_method_page_page_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
keyboard_input_method_page_page_get_instance_private (KeyboardInputMethodPagePage* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardInputMethodPagePage_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gchar*
keyboard_input_method_page_page_get_keyboard_shortcut (KeyboardInputMethodPagePage* self)
{
	gchar** keyboard_shortcuts = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	gchar* keyboard_shortcut = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = keyboard_plug_ibus_general_settings;
	_tmp1_ = g_settings_get_child (_tmp0_, "hotkey");
	_tmp2_ = _tmp1_;
	_tmp4_ = _tmp3_ = g_settings_get_strv (_tmp2_, "triggers");
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _vala_array_length (_tmp3_);
	_g_object_unref0 (_tmp2_);
	keyboard_shortcuts = _tmp5_;
	keyboard_shortcuts_length1 = _tmp5__length1;
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
	_tmp6_ = g_strdup ("");
	keyboard_shortcut = _tmp6_;
	_tmp7_ = keyboard_shortcuts;
	_tmp7__length1 = keyboard_shortcuts_length1;
	{
		gchar** ks_collection = NULL;
		gint ks_collection_length1 = 0;
		gint _ks_collection_size_ = 0;
		gint ks_it = 0;
		ks_collection = _tmp7_;
		ks_collection_length1 = _tmp7__length1;
		for (ks_it = 0; ks_it < ks_collection_length1; ks_it = ks_it + 1) {
			gchar* _tmp8_;
			gchar* ks = NULL;
			_tmp8_ = g_strdup (ks_collection[ks_it]);
			ks = _tmp8_;
			{
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GQuark _tmp12_ = 0U;
				static GQuark _tmp11_label0 = 0;
				static GQuark _tmp11_label1 = 0;
				static GQuark _tmp11_label2 = 0;
				_tmp9_ = ks;
				_tmp10_ = _tmp9_;
				_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
				if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("<Alt>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp13_;
							_tmp13_ = g_strdup ("alt-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp13_;
							break;
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("<Shift>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp14_;
							_tmp14_ = g_strdup ("shift-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp14_;
							break;
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("<Control>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp15_;
							_tmp15_ = g_strdup ("ctl-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp15_;
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							break;
						}
					}
				}
				_g_free0 (ks);
			}
		}
	}
	result = keyboard_shortcut;
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
keyboard_input_method_page_page_set_keyboard_shortcut (KeyboardInputMethodPagePage* self,
                                                       const gchar* combobox_id)
{
	gchar** keyboard_shortcuts = NULL;
	gchar** _tmp0_;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combobox_id != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	keyboard_shortcuts = _tmp0_;
	keyboard_shortcuts_length1 = 0;
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
	_tmp1_ = combobox_id;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("alt-space")))) {
		switch (0) {
			default:
			{
				gchar* _tmp4_;
				_tmp4_ = g_strdup ("<Alt>space");
				_vala_array_add3 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp4_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("shift-space")))) {
		switch (0) {
			default:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("<Shift>space");
				_vala_array_add4 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp5_);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("<Control>space");
				_vala_array_add5 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp6_);
				break;
			}
		}
	}
	_tmp7_ = keyboard_plug_ibus_general_settings;
	_tmp8_ = g_settings_get_child (_tmp7_, "hotkey");
	_tmp9_ = _tmp8_;
	_tmp10_ = keyboard_shortcuts;
	_tmp10__length1 = keyboard_shortcuts_length1;
	g_settings_set_strv (_tmp9_, "triggers", _tmp10_);
	_g_object_unref0 (_tmp9_);
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
}

static void
__lambda58_ (KeyboardInputMethodPagePage* self,
             GtkWidget* listbox_child)
{
	g_return_if_fail (listbox_child != NULL);
	gtk_widget_destroy (listbox_child);
}

static void
___lambda58__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda58_ ((KeyboardInputMethodPagePage*) self, widget);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
keyboard_input_method_page_page_update_engines_list (KeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	GList* _tmp1_;
	GtkListBox* _tmp2_;
	KeyboardSourceSettings* _tmp3_;
	KeyboardLayoutType _tmp4_;
	KeyboardSourceSettings* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkListBox* _tmp44_;
	GtkMenuButton* _tmp45_;
	GtkListBox* _tmp46_;
	GtkListBoxRow* _tmp47_;
	GtkStack* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->bus;
	_tmp1_ = ibus_bus_list_engines (_tmp0_);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	self->priv->engines = _tmp1_;
	_tmp2_ = self->priv->listbox;
	gtk_container_foreach ((GtkContainer*) _tmp2_, ___lambda58__gtk_callback, self);
	_tmp3_ = self->priv->settings;
	_tmp4_ = KEYBOARD_LAYOUT_TYPE_IBUS;
	keyboard_source_settings_reset (_tmp3_, &_tmp4_, TRUE);
	_tmp5_ = self->priv->settings;
	_tmp6_ = keyboard_source_settings_get_active_engines (_tmp5_, &_tmp7_);
	_tmp6__length1 = _tmp7_;
	_tmp8_ = _tmp6_;
	_tmp8__length1 = _tmp6__length1;
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
		active_engine_collection = _tmp8_;
		active_engine_collection_length1 = _tmp8__length1;
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
			gchar* _tmp9_;
			gchar* active_engine = NULL;
			_tmp9_ = g_strdup (active_engine_collection[active_engine_it]);
			active_engine = _tmp9_;
			{
				GList* _tmp10_;
				_tmp10_ = self->priv->engines;
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
					engine_collection = _tmp10_;
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
						IBusEngineDesc* _tmp11_;
						IBusEngineDesc* engine = NULL;
						_tmp11_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
						engine = _tmp11_;
						{
							IBusEngineDesc* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
							_tmp12_ = engine;
							_tmp13_ = ibus_engine_desc_get_name (_tmp12_);
							_tmp14_ = _tmp13_;
							_tmp15_ = active_engine;
							if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
								gchar* engine_full_name = NULL;
								IBusEngineDesc* _tmp16_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
								IBusEngineDesc* _tmp21_;
								gchar* _tmp22_;
								gchar* _tmp23_;
								gchar* _tmp24_;
								gchar* _tmp25_;
								GtkLabel* label = NULL;
								const gchar* _tmp26_;
								GtkLabel* _tmp27_ = NULL;
								GtkListBoxRow* listboxrow = NULL;
								GtkListBoxRow* _tmp28_;
								GtkListBoxRow* _tmp29_;
								IBusEngineDesc* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								gchar* _tmp33_;
								GtkListBoxRow* _tmp34_;
								GtkLabel* _tmp35_;
								GtkListBox* _tmp36_;
								GtkListBoxRow* _tmp37_;
								KeyboardSourceSettings* _tmp38_;
								IBusEngineDesc* _tmp39_;
								const gchar* _tmp40_;
								const gchar* _tmp41_;
								KeyboardInputSource* _tmp42_;
								KeyboardInputSource* _tmp43_;
								_tmp16_ = engine;
								_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
								_tmp18_ = _tmp17_;
								_tmp19_ = ibus_get_language_name (_tmp18_);
								_tmp20_ = _tmp19_;
								_tmp21_ = engine;
								_tmp22_ = keyboard_input_method_page_page_gettext_engine_longname (self, _tmp21_);
								_tmp23_ = _tmp22_;
								_tmp24_ = g_strdup_printf ("%s - %s", _tmp20_, _tmp23_);
								_tmp25_ = _tmp24_;
								_g_free0 (_tmp23_);
								_g_free0 (_tmp20_);
								engine_full_name = _tmp25_;
								_tmp26_ = engine_full_name;
								_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
								gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_START);
								g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
								g_object_ref_sink (_tmp27_);
								label = _tmp27_;
								_tmp28_ = (GtkListBoxRow*) gtk_list_box_row_new ();
								g_object_ref_sink (_tmp28_);
								listboxrow = _tmp28_;
								_tmp29_ = listboxrow;
								_tmp30_ = engine;
								_tmp31_ = ibus_engine_desc_get_name (_tmp30_);
								_tmp32_ = _tmp31_;
								_tmp33_ = g_strdup (_tmp32_);
								g_object_set_data_full ((GObject*) _tmp29_, "engine-name", _tmp33_, g_free);
								_tmp34_ = listboxrow;
								_tmp35_ = label;
								gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
								_tmp36_ = self->priv->listbox;
								_tmp37_ = listboxrow;
								gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
								_tmp38_ = self->priv->settings;
								_tmp39_ = engine;
								_tmp40_ = ibus_engine_desc_get_name (_tmp39_);
								_tmp41_ = _tmp40_;
								_tmp42_ = keyboard_input_source_new_ibus (_tmp41_);
								_tmp43_ = _tmp42_;
								keyboard_source_settings_add_layout (_tmp38_, _tmp43_);
								_g_object_unref0 (_tmp43_);
								_g_object_unref0 (listboxrow);
								_g_object_unref0 (label);
								_g_free0 (engine_full_name);
							}
							_g_object_unref0 (engine);
						}
					}
				}
				_g_free0 (active_engine);
			}
		}
	}
	_tmp44_ = self->priv->listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp44_);
	_tmp45_ = self->priv->remove_button;
	_tmp46_ = self->priv->listbox;
	_tmp47_ = gtk_list_box_get_selected_row (_tmp46_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp45_, _tmp47_ != NULL);
	_tmp48_ = self->priv->stack;
	_tmp49_ = gtk_stack_get_visible_child_name (_tmp48_);
	_tmp50_ = _tmp49_;
	if (g_strcmp0 (_tmp50_, "main_view") == 0) {
		GtkListBox* _tmp51_;
		GList* _tmp52_;
		GList* _tmp53_;
		_tmp51_ = self->priv->listbox;
		_tmp52_ = gtk_container_get_children ((GtkContainer*) _tmp51_);
		_tmp53_ = _tmp52_;
		keyboard_input_method_page_page_write_ibus_autostart_file (self, g_list_length (_tmp53_) > ((guint) 0));
		(_tmp53_ == NULL) ? NULL : (_tmp53_ = (g_list_free (_tmp53_), NULL));
	}
}

static gboolean
__lambda59_ (KeyboardInputMethodPagePage* self)
{
	gboolean result;
	keyboard_input_method_page_page_set_visible_view (self, "");
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
___lambda59__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda59_ ((KeyboardInputMethodPagePage*) self);
	return result;
}

static void
keyboard_input_method_page_page_spawn_ibus_daemon (KeyboardInputMethodPagePage* self)
{
	gboolean is_spawn_succeeded = FALSE;
	guint timeout_start_daemon = 0U;
	GtkListBox* _tmp13_;
	GList* _tmp14_;
	GList* _tmp15_;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	is_spawn_succeeded = FALSE;
	{
		gboolean _tmp0_ = FALSE;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gboolean _tmp8_;
		_tmp1_ = g_strdup ("ibus-daemon");
		_tmp2_ = g_strdup ("-drx");
		_tmp3_ = g_new0 (gchar*, 2 + 1);
		_tmp3_[0] = _tmp1_;
		_tmp3_[1] = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp4__length1 = 2;
		_tmp6_ = _tmp5_ = g_get_environ ();
		_tmp7_ = _tmp6_;
		_tmp7__length1 = _vala_array_length (_tmp5_);
		_tmp8_ = g_spawn_sync ("/", _tmp4_, _tmp7_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
		_tmp0_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch0_g_spawn_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		is_spawn_succeeded = _tmp0_;
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("InputMethod.vala:343: %s", _tmp10_);
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		keyboard_input_method_page_page_set_visible_view (self, _tmp12_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	timeout_start_daemon = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda59__gsource_func, g_object_ref (self), g_object_unref);
	timeout_start_daemon = (guint) 0;
	_tmp13_ = self->priv->listbox;
	_tmp14_ = gtk_container_get_children ((GtkContainer*) _tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = is_spawn_succeeded & (g_list_length (_tmp15_) > ((guint) 0));
	(_tmp15_ == NULL) ? NULL : (_tmp15_ = (g_list_free (_tmp15_), NULL));
	if (_tmp16_) {
		keyboard_input_method_page_page_write_ibus_autostart_file (self, TRUE);
	}
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
keyboard_input_method_page_page_write_ibus_autostart_file (KeyboardInputMethodPagePage* self,
                                                           gboolean enable)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** languages = NULL;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint languages_length1;
	gint _languages_size_;
	gchar* preferred_language = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp16_;
	GKeyFile* _tmp17_;
	const gchar* _tmp18_;
	GKeyFile* _tmp19_;
	const gchar* _tmp20_;
	GKeyFile* _tmp21_;
	GKeyFile* _tmp22_;
	GKeyFile* _tmp23_;
	GKeyFile* _tmp24_;
	gchar* path = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	config_dir = _tmp1_;
	_tmp2_ = config_dir;
	_tmp3_ = g_build_filename (_tmp2_, "autostart", NULL);
	startup_dir = _tmp3_;
	_tmp4_ = startup_dir;
	if (!g_file_test (_tmp4_, G_FILE_TEST_EXISTS)) {
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		_tmp5_ = startup_dir;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		file = _tmp6_;
		{
			GFile* _tmp7_;
			_tmp7_ = file;
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("InputMethod.vala:371: %s", _tmp9_);
			_g_error_free0 (e);
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (file);
	}
	_tmp11_ = _tmp10_ = g_get_language_names ();
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup4 (_tmp11_, _vala_array_length (_tmp10_)) : _tmp11_;
	_tmp12__length1 = _vala_array_length (_tmp10_);
	languages = _tmp12_;
	languages_length1 = _tmp12__length1;
	_languages_size_ = languages_length1;
	_tmp13_ = languages;
	_tmp13__length1 = languages_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = g_strdup (_tmp14_);
	preferred_language = _tmp15_;
	_tmp16_ = g_key_file_new ();
	keyfile = _tmp16_;
	_tmp17_ = keyfile;
	_tmp18_ = preferred_language;
	g_key_file_set_locale_string (_tmp17_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_NAME, _tmp18_, _ ("IBus Daemon"));
	_tmp19_ = keyfile;
	_tmp20_ = preferred_language;
	g_key_file_set_locale_string (_tmp19_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_COMMENT, _tmp20_, _ ("Use and manage input methods"));
	_tmp21_ = keyfile;
	g_key_file_set_string (_tmp21_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, "ibus-daemon -drx");
	_tmp22_ = keyfile;
	g_key_file_set_string (_tmp22_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, "ibus-setup");
	_tmp23_ = keyfile;
	g_key_file_set_string (_tmp23_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, "Application");
	_tmp24_ = keyfile;
	g_key_file_set_boolean (_tmp24_, G_KEY_FILE_DESKTOP_GROUP, "X-GNOME-Autostart-enabled", enable);
	_tmp25_ = startup_dir;
	_tmp26_ = g_build_filename (_tmp25_, "ibus-daemon.desktop", NULL);
	path = _tmp26_;
	{
		const gchar* _tmp27_;
		GKeyFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp27_ = path;
		_tmp28_ = keyfile;
		_tmp29_ = g_key_file_to_data (_tmp28_, NULL, NULL);
		_tmp30_ = _tmp29_;
		g_file_set_contents (_tmp27_, _tmp30_, (gssize) -1, &_inner_error0_);
		_g_free0 (_tmp30_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp31_ = path;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		g_warning ("InputMethod.vala:397: Could not write to file %s: %s", _tmp31_, _tmp33_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		_g_key_file_unref0 (keyfile);
		_g_free0 (preferred_language);
		languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (startup_dir);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (path);
	_g_key_file_unref0 (keyfile);
	_g_free0 (preferred_language);
	languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (startup_dir);
	_g_free0 (config_dir);
}

static void
keyboard_input_method_page_page_set_visible_view (KeyboardInputMethodPagePage* self,
                                                  const gchar* error_message)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (error_message != NULL);
	if (g_strcmp0 (error_message, "") != 0) {
		GtkStack* _tmp0_;
		GraniteWidgetsAlertView* _tmp1_;
		_tmp0_ = self->priv->stack;
		gtk_stack_set_visible_child_name (_tmp0_, "spawn_failed_view");
		_tmp1_ = self->priv->spawn_failed_alert;
		granite_widgets_alert_view_set_description (_tmp1_, error_message);
	} else {
		IBusBus* _tmp2_;
		_tmp2_ = self->priv->bus;
		if (ibus_bus_is_connected (_tmp2_)) {
			GtkStack* _tmp3_;
			_tmp3_ = self->priv->stack;
			gtk_stack_set_visible_child_name (_tmp3_, "main_view");
			keyboard_input_method_page_page_update_engines_list (self);
			keyboard_input_method_page_page_update_popover_engines_list (self);
		} else {
			GtkStack* _tmp4_;
			_tmp4_ = self->priv->stack;
			gtk_stack_set_visible_child_name (_tmp4_, "no_daemon_runnning_view");
		}
	}
}

static gchar*
keyboard_input_method_page_page_gettext_engine_longname (KeyboardInputMethodPagePage* self,
                                                         IBusEngineDesc* engine)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* textdomain = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (engine != NULL, NULL);
	_tmp0_ = ibus_engine_desc_get_name (engine);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	name = _tmp2_;
	_tmp3_ = name;
	if (g_str_has_prefix (_tmp3_, "xkb:")) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = ibus_engine_desc_get_longname (engine);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup (g_dgettext ("xkeyboard-config", _tmp5_));
		result = _tmp6_;
		_g_free0 (name);
		return result;
	}
	_tmp7_ = ibus_engine_desc_get_textdomain (engine);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strdup (_tmp8_);
	textdomain = _tmp9_;
	_tmp10_ = textdomain;
	if (g_strcmp0 (_tmp10_, "") == 0) {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp11_ = ibus_engine_desc_get_longname (engine);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strdup (_tmp12_);
		result = _tmp13_;
		_g_free0 (textdomain);
		_g_free0 (name);
		return result;
	}
	_tmp14_ = textdomain;
	_tmp15_ = ibus_engine_desc_get_longname (engine);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strdup (g_dgettext (_tmp14_, _tmp16_));
	result = _tmp17_;
	_g_free0 (textdomain);
	_g_free0 (name);
	return result;
}

void
keyboard_input_method_page_page_update_popover_engines_list (KeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	GList* _tmp2_;
	GList* engine_lists = NULL;
	GList* _tmp3_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp20_;
	GList* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ibus_bus_new ();
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = ibus_bus_list_engines (_tmp1_);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	self->priv->engines = _tmp2_;
	_g_object_unref0 (_tmp1_);
	engine_lists = NULL;
	_tmp3_ = self->priv->engines;
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
		engine_collection = _tmp3_;
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
			IBusEngineDesc* _tmp4_;
			IBusEngineDesc* engine = NULL;
			_tmp4_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
			engine = _tmp4_;
			{
				gchar* full_name = NULL;
				IBusEngineDesc* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				IBusEngineDesc* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				IBusEngineDesc* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				KeyboardInputMethodPageAddEnginesList* _tmp19_;
				_tmp5_ = engine;
				_tmp6_ = ibus_engine_desc_get_language (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = ibus_get_language_name (_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = engine;
				_tmp11_ = keyboard_input_method_page_page_gettext_engine_longname (self, _tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = g_strdup_printf ("%s - %s", _tmp9_, _tmp12_);
				_tmp14_ = _tmp13_;
				_g_free0 (_tmp12_);
				_g_free0 (_tmp9_);
				full_name = _tmp14_;
				_tmp15_ = engine;
				_tmp16_ = ibus_engine_desc_get_name (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = full_name;
				_tmp19_ = keyboard_input_method_page_add_engines_list_new (_tmp17_, _tmp18_);
				engine_lists = g_list_append (engine_lists, _tmp19_);
				_g_free0 (full_name);
				_g_object_unref0 (engine);
			}
		}
	}
	_tmp20_ = self->priv->add_engines_popover;
	_tmp21_ = engine_lists;
	keyboard_input_method_page_add_engines_popover_update_engines_list (_tmp20_, _tmp21_);
	(engine_lists == NULL) ? NULL : (engine_lists = (_g_list_free__g_object_unref0_ (engine_lists), NULL));
}

static void
keyboard_input_method_page_page_update_entry_test_usable (KeyboardInputMethodPagePage* self)
{
	gboolean _tmp0_ = FALSE;
	KeyboardSourceSettings* _tmp1_;
	KeyboardInputSource* _tmp2_;
	KeyboardInputSource* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->settings;
	_tmp2_ = keyboard_source_settings_get_active_input_source (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		KeyboardSourceSettings* _tmp4_;
		KeyboardInputSource* _tmp5_;
		KeyboardInputSource* _tmp6_;
		KeyboardLayoutType _tmp7_;
		KeyboardLayoutType _tmp8_;
		_tmp4_ = self->priv->settings;
		_tmp5_ = keyboard_source_settings_get_active_input_source (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = keyboard_input_source_get_layout_type (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_ == KEYBOARD_LAYOUT_TYPE_IBUS;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkEntry* _tmp9_;
		GtkEntry* _tmp10_;
		_tmp9_ = self->priv->entry_test;
		gtk_entry_set_placeholder_text (_tmp9_, _ ("Type to test your input method"));
		_tmp10_ = self->priv->entry_test;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
	} else {
		GtkEntry* _tmp11_;
		GtkEntry* _tmp12_;
		_tmp11_ = self->priv->entry_test;
		gtk_entry_set_placeholder_text (_tmp11_, _ ("A keyboard layout is active"));
		_tmp12_ = self->priv->entry_test;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		KeyboardInputMethodPagePage* self;
		self = _data14_->self;
		_g_free0 (_data14_->engine_name);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}

static void
__lambda60_ (Block14Data* _data14_,
             GtkWidget* widget)
{
	KeyboardInputMethodPagePage* self;
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp0_;
	gchar* row_name = NULL;
	GtkListBoxRow* _tmp1_;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	self = _data14_->self;
	g_return_if_fail (widget != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_list_box_row_get_type (), GtkListBoxRow));
	row = _tmp0_;
	_tmp1_ = row;
	_tmp2_ = g_object_get_data ((GObject*) _tmp1_, "engine-name");
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
	row_name = _tmp3_;
	_tmp4_ = row_name;
	_tmp5_ = _data14_->engine_name;
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
		GtkListBox* _tmp6_;
		GtkListBoxRow* _tmp7_;
		_tmp6_ = self->priv->listbox;
		_tmp7_ = row;
		gtk_list_box_select_row (_tmp6_, _tmp7_);
	} else {
		GtkListBox* _tmp8_;
		GtkListBoxRow* _tmp9_;
		_tmp8_ = self->priv->listbox;
		_tmp9_ = row;
		gtk_list_box_unselect_row (_tmp8_, _tmp9_);
	}
	_g_free0 (row_name);
	_g_object_unref0 (row);
}

static void
___lambda60__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda60_ (self, widget);
}

static void
keyboard_input_method_page_page_update_list_box_selected_row (KeyboardInputMethodPagePage* self)
{
	Block14Data* _data14_;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	KeyboardSourceSettings* _tmp2_;
	KeyboardInputSource* _tmp3_;
	KeyboardInputSource* _tmp4_;
	GtkListBox* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkListBox* _tmp20_;
	GtkListBoxRow* _tmp21_;
	g_return_if_fail (self != NULL);
	_data14_ = g_slice_new0 (Block14Data);
	_data14_->_ref_count_ = 1;
	_data14_->self = g_object_ref (self);
	_tmp0_ = g_strdup ("");
	_data14_->engine_name = _tmp0_;
	_tmp2_ = self->priv->settings;
	_tmp3_ = keyboard_source_settings_get_active_input_source (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != NULL) {
		KeyboardSourceSettings* _tmp5_;
		KeyboardInputSource* _tmp6_;
		KeyboardInputSource* _tmp7_;
		KeyboardLayoutType _tmp8_;
		KeyboardLayoutType _tmp9_;
		_tmp5_ = self->priv->settings;
		_tmp6_ = keyboard_source_settings_get_active_input_source (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = keyboard_input_source_get_layout_type (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp1_ = _tmp9_ == KEYBOARD_LAYOUT_TYPE_IBUS;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		KeyboardSourceSettings* _tmp10_;
		KeyboardInputSource* _tmp11_;
		KeyboardInputSource* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		IBusBus* _tmp16_;
		const gchar* _tmp17_;
		_tmp10_ = self->priv->settings;
		_tmp11_ = keyboard_source_settings_get_active_input_source (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = keyboard_input_source_get_name (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup (_tmp14_);
		_g_free0 (_data14_->engine_name);
		_data14_->engine_name = _tmp15_;
		_tmp16_ = self->priv->bus;
		_tmp17_ = _data14_->engine_name;
		ibus_bus_set_global_engine (_tmp16_, _tmp17_);
	}
	_tmp18_ = self->priv->listbox;
	gtk_container_foreach ((GtkContainer*) _tmp18_, ___lambda60__gtk_callback, _data14_);
	_tmp19_ = self->priv->remove_button;
	_tmp20_ = self->priv->listbox;
	_tmp21_ = gtk_list_box_get_selected_row (_tmp20_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp21_ != NULL);
	block14_data_unref (_data14_);
	_data14_ = NULL;
}

KeyboardInputMethodPagePage*
keyboard_input_method_page_page_construct (GType object_type)
{
	KeyboardInputMethodPagePage * self = NULL;
	self = (KeyboardInputMethodPagePage*) g_object_new (object_type, NULL);
	return self;
}

KeyboardInputMethodPagePage*
keyboard_input_method_page_page_new (void)
{
	return keyboard_input_method_page_page_construct (KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE);
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
	g_atomic_int_inc (&_data15_->_ref_count_);
	return _data15_;
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
		KeyboardInputMethodPagePage* self;
		self = _data15_->self;
		_g_object_unref0 (_data15_->keyboard_shortcut_combobox);
		_g_object_unref0 (self);
		g_slice_free (Block15Data, _data15_);
	}
}

static void
_keyboard_input_method_page_page___lambda61_ (KeyboardInputMethodPagePage* self)
{
	keyboard_input_method_page_page_spawn_ibus_daemon (self);
}

static void
__keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                           gpointer self)
{
	_keyboard_input_method_page_page___lambda61_ ((KeyboardInputMethodPagePage*) self);
}

static void
_keyboard_input_method_page_page___lambda62_ (KeyboardInputMethodPagePage* self,
                                              GtkListBoxRow* row)
{
	gboolean _tmp0_ = FALSE;
	if (!self->priv->selection_changing) {
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ());
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* engine_name = NULL;
		gconstpointer _tmp1_;
		gchar* _tmp2_;
		KeyboardSourceSettings* _tmp3_;
		const gchar* _tmp4_;
		IBusBus* _tmp5_;
		const gchar* _tmp6_;
		self->priv->selection_changing = TRUE;
		_tmp1_ = g_object_get_data ((GObject*) row, "engine-name");
		_tmp2_ = g_strdup ((const gchar*) _tmp1_);
		engine_name = _tmp2_;
		_tmp3_ = self->priv->settings;
		_tmp4_ = engine_name;
		keyboard_source_settings_set_active_engine_name (_tmp3_, _tmp4_);
		_tmp5_ = self->priv->bus;
		_tmp6_ = engine_name;
		ibus_bus_set_global_engine (_tmp5_, _tmp6_);
		keyboard_input_method_page_page_update_entry_test_usable (self);
		self->priv->selection_changing = FALSE;
		_g_free0 (engine_name);
	}
}

static void
__keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                         GtkListBoxRow* row,
                                                                         gpointer self)
{
	_keyboard_input_method_page_page___lambda62_ ((KeyboardInputMethodPagePage*) self, row);
}

static void
_keyboard_input_method_page_page___lambda63_ (KeyboardInputMethodPagePage* self,
                                              const gchar* name)
{
	g_return_if_fail (name != NULL);
	keyboard_input_method_page_page_update_list_box_selected_row (self);
	keyboard_input_method_page_page_update_entry_test_usable (self);
}

static void
__keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                              const gchar* name,
                                                                              gpointer self)
{
	_keyboard_input_method_page_page___lambda63_ ((KeyboardInputMethodPagePage*) self, name);
}

static void
_keyboard_input_method_page_page___lambda64_ (KeyboardInputMethodPagePage* self)
{
	KeyboardInputMethodPageAddEnginesPopover* _tmp0_;
	_tmp0_ = self->priv->add_engines_popover;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
}

static void
__keyboard_input_method_page_page___lambda64__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
	_keyboard_input_method_page_page___lambda64_ ((KeyboardInputMethodPagePage*) self);
}

static void
_keyboard_input_method_page_page___lambda65_ (KeyboardInputMethodPagePage* self,
                                              const gchar* engine)
{
	KeyboardSourceSettings* _tmp0_;
	g_return_if_fail (engine != NULL);
	_tmp0_ = self->priv->settings;
	if (keyboard_source_settings_add_active_engine (_tmp0_, engine)) {
		keyboard_input_method_page_page_update_engines_list (self);
	}
}

static void
__keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine (KeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                         const gchar* new_engine,
                                                                                                         gpointer self)
{
	_keyboard_input_method_page_page___lambda65_ ((KeyboardInputMethodPagePage*) self, new_engine);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
	self = *((gchar**) data);
	_g_free0_ (self);
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_assert (self->len > index, "length > index");
	_tmp0_ = self->data;
	_tmp0__length1 = self->len;
	_tmp1_ = _tmp0_[index];
	_tmp0_[index] = NULL;
	g = _tmp1_;
	g_array_remove_index (self, index);
	result = g;
	return result;
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_keyboard_input_method_page_page___lambda66_ (KeyboardInputMethodPagePage* self)
{
	gint index = 0;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GArray* removed_lists = NULL;
	GArray* _tmp2_;
	KeyboardSourceSettings* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GArray* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** new_engines = NULL;
	gint new_engines_length1 = 0;
	gint _new_engines_size_ = 0;
	KeyboardSourceSettings* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	KeyboardSourceSettings* _tmp22_;
	_tmp0_ = self->priv->listbox;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	index = gtk_list_box_row_get_index (_tmp1_);
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_gchar_free_function_content_of);
	removed_lists = _tmp2_;
	_tmp3_ = self->priv->settings;
	_tmp4_ = keyboard_source_settings_get_active_engines (_tmp3_, &_tmp5_);
	_tmp4__length1 = _tmp5_;
	_tmp6_ = _tmp4_;
	_tmp6__length1 = _tmp4__length1;
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
		active_engine_collection = _tmp6_;
		active_engine_collection_length1 = _tmp6__length1;
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
			gchar* _tmp7_;
			gchar* active_engine = NULL;
			_tmp7_ = g_strdup (active_engine_collection[active_engine_it]);
			active_engine = _tmp7_;
			{
				GArray* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				_tmp8_ = removed_lists;
				_tmp9_ = active_engine;
				_tmp10_ = g_strdup (_tmp9_);
				g_array_append_val (_tmp8_, _tmp10_);
				_g_free0 (active_engine);
			}
		}
	}
	_tmp11_ = removed_lists;
	_tmp12_ = vala_g_array_remove_index (_tmp11_, (guint) index);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp13_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				GArray* _tmp16_;
				GArray* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = removed_lists;
				if (!(((guint) i) < _tmp16_->len)) {
					break;
				}
				_tmp17_ = removed_lists;
				_tmp18_ = g_array_index (_tmp17_, gchar*, (guint) i);
				_tmp19_ = g_strdup (_tmp18_);
				_vala_array_add6 (&new_engines, &new_engines_length1, &_new_engines_size_, _tmp19_);
			}
		}
	}
	_tmp20_ = self->priv->settings;
	_tmp21_ = new_engines;
	_tmp21__length1 = new_engines_length1;
	keyboard_source_settings_set_active_engines (_tmp20_, _tmp21_, _tmp21__length1);
	keyboard_input_method_page_page_update_engines_list (self);
	_tmp22_ = self->priv->settings;
	keyboard_source_settings_set_active_index (_tmp22_, (guint) 0);
	new_engines = (_vala_array_free (new_engines, new_engines_length1, (GDestroyNotify) g_free), NULL);
	_g_array_unref0 (removed_lists);
}

static void
__keyboard_input_method_page_page___lambda66__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
	_keyboard_input_method_page_page___lambda66_ ((KeyboardInputMethodPagePage*) self);
}

static void
_keyboard_input_method_page_page___lambda67_ (Block15Data* _data15_)
{
	KeyboardInputMethodPagePage* self;
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = _data15_->self;
	_tmp0_ = _data15_->keyboard_shortcut_combobox;
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp0_);
	_tmp2_ = _tmp1_;
	keyboard_input_method_page_page_set_keyboard_shortcut (self, _tmp2_);
}

static void
__keyboard_input_method_page_page___lambda67__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
	_keyboard_input_method_page_page___lambda67_ (self);
}

static void
_keyboard_input_method_page_page___lambda68_ (KeyboardInputMethodPagePage* self)
{
	keyboard_input_method_page_page_update_list_box_selected_row (self);
	keyboard_input_method_page_page_update_entry_test_usable (self);
}

static void
__keyboard_input_method_page_page___lambda68__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
	_keyboard_input_method_page_page___lambda68_ ((KeyboardInputMethodPagePage*) self);
}

static GObject *
keyboard_input_method_page_page_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardInputMethodPagePage * self;
	Block15Data* _data15_;
	KeyboardSourceSettings* _tmp0_;
	IBusBus* _tmp1_;
	GSettings* _tmp2_;
	GSettings* keyboard_settings = NULL;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GraniteWidgetsAlertView* no_daemon_runnning_alert = NULL;
	GraniteWidgetsAlertView* _tmp9_ = NULL;
	GraniteWidgetsAlertView* _tmp10_;
	GtkStyleContext* _tmp11_;
	GraniteWidgetsAlertView* _tmp12_;
	GraniteWidgetsAlertView* _tmp13_;
	GraniteWidgetsAlertView* _tmp14_ = NULL;
	GraniteWidgetsAlertView* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkListBox* _tmp17_ = NULL;
	GtkListBox* _tmp18_;
	IBusBus* _tmp19_;
	IBusBus* _tmp20_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp21_ = NULL;
	GtkScrolledWindow* _tmp22_;
	GtkListBox* _tmp23_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp24_;
	GtkMenuButton* add_button = NULL;
	GtkImage* _tmp25_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp26_;
	GtkPopover* _tmp27_;
	gchar* _tmp28_;
	GtkMenuButton* _tmp29_ = NULL;
	GtkImage* _tmp30_;
	gchar* _tmp31_;
	GtkMenuButton* _tmp32_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkActionBar* _tmp36_;
	GtkMenuButton* _tmp37_;
	GtkActionBar* _tmp38_;
	GtkMenuButton* _tmp39_;
	GtkGrid* left_grid = NULL;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	GtkGrid* _tmp43_;
	GtkActionBar* _tmp44_;
	GtkFrame* display = NULL;
	GtkFrame* _tmp45_;
	GtkFrame* _tmp46_;
	GtkGrid* _tmp47_;
	GtkLabel* keyboard_shortcut_label = NULL;
	GtkLabel* _tmp48_ = NULL;
	GtkComboBoxText* _tmp49_ = NULL;
	GtkComboBoxText* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GtkComboBoxText* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	GtkComboBoxText* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	GtkComboBoxText* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GtkLabel* show_ibus_panel_label = NULL;
	GtkLabel* _tmp62_ = NULL;
	GtkComboBoxText* show_ibus_panel_combobox = NULL;
	GtkComboBoxText* _tmp63_ = NULL;
	GtkComboBoxText* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkComboBoxText* _tmp66_;
	GtkLabel* embed_preedit_text_label = NULL;
	GtkLabel* _tmp67_ = NULL;
	GtkSwitch* embed_preedit_text_switch = NULL;
	GtkSwitch* _tmp68_ = NULL;
	GtkEntry* _tmp69_ = NULL;
	GtkGrid* right_grid = NULL;
	GtkGrid* _tmp70_ = NULL;
	GtkGrid* _tmp71_;
	GtkLabel* _tmp72_;
	GtkGrid* _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkGrid* _tmp75_;
	GtkLabel* _tmp76_;
	GtkGrid* _tmp77_;
	GtkComboBoxText* _tmp78_;
	GtkGrid* _tmp79_;
	GtkLabel* _tmp80_;
	GtkGrid* _tmp81_;
	GtkSwitch* _tmp82_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp83_ = NULL;
	GtkGrid* _tmp84_;
	GtkFrame* _tmp85_;
	GtkGrid* _tmp86_;
	GtkGrid* _tmp87_;
	GtkGrid* _tmp88_;
	GtkEntry* _tmp89_;
	GtkStack* _tmp90_;
	GtkStack* _tmp91_;
	GraniteWidgetsAlertView* _tmp92_;
	GtkStack* _tmp93_;
	GraniteWidgetsAlertView* _tmp94_;
	GtkStack* _tmp95_;
	GtkGrid* _tmp96_;
	GtkStack* _tmp97_;
	GtkStack* _tmp98_;
	GtkMenuButton* _tmp99_;
	KeyboardInputMethodPageAddEnginesPopover* _tmp100_;
	GtkMenuButton* _tmp101_;
	GtkComboBoxText* _tmp102_;
	GSettings* _tmp103_;
	GtkComboBoxText* _tmp104_;
	GSettings* _tmp105_;
	GtkSwitch* _tmp106_;
	KeyboardSourceSettings* _tmp107_;
	parent_class = G_OBJECT_CLASS (keyboard_input_method_page_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, KeyboardInputMethodPagePage);
	_data15_ = g_slice_new0 (Block15Data);
	_data15_->_ref_count_ = 1;
	_data15_->self = g_object_ref (self);
	_tmp0_ = keyboard_source_settings_get_instance ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = ibus_bus_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->bus);
	self->priv->bus = _tmp1_;
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
	_g_object_unref0 (self->priv->ibus_panel_settings);
	self->priv->ibus_panel_settings = _tmp2_;
	_tmp3_ = g_settings_new ("io.elementary.switchboard.keyboard");
	keyboard_settings = _tmp3_;
	_tmp4_ = keyboard_settings;
	if (g_settings_get_boolean (_tmp4_, "first-launch")) {
		GSettings* _tmp5_;
		GSettings* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp5_ = keyboard_settings;
		g_settings_set_boolean (_tmp5_, "first-launch", FALSE);
		_tmp6_ = keyboard_plug_ibus_general_settings;
		_tmp7_ = g_new0 (gchar*, 0 + 1);
		_tmp8_ = _tmp7_;
		_tmp8__length1 = 0;
		g_settings_set_strv (_tmp6_, "preload-engines", _tmp8_);
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp9_ = granite_widgets_alert_view_new (_ ("IBus Daemon is not running"), _ ("You need to run the IBus daemon to enable or configure input method en" \
"gines."), "dialog-information");
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp9_);
	no_daemon_runnning_alert = _tmp9_;
	_tmp10_ = no_daemon_runnning_alert;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_remove_class (_tmp11_, GTK_STYLE_CLASS_VIEW);
	_tmp12_ = no_daemon_runnning_alert;
	granite_widgets_alert_view_show_action (_tmp12_, _ ("Start IBus Daemon"));
	_tmp13_ = no_daemon_runnning_alert;
	g_signal_connect_object (_tmp13_, "action-activated", (GCallback) __keyboard_input_method_page_page___lambda61__granite_widgets_alert_view_action_activated, self, 0);
	_tmp14_ = granite_widgets_alert_view_new (_ ("Could not start the IBus daemon"), "", "dialog-error");
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->spawn_failed_alert);
	self->priv->spawn_failed_alert = _tmp14_;
	_tmp15_ = self->priv->spawn_failed_alert;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_remove_class (_tmp16_, GTK_STYLE_CLASS_VIEW);
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_selection_mode (_tmp17_, GTK_SELECTION_BROWSE);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp17_;
	_tmp18_ = self->priv->listbox;
	g_signal_connect_object (_tmp18_, "row-selected", (GCallback) __keyboard_input_method_page_page___lambda62__gtk_list_box_row_selected, self, 0);
	_tmp19_ = self->priv->bus;
	ibus_bus_set_watch_ibus_signal (_tmp19_, TRUE);
	_tmp20_ = self->priv->bus;
	g_signal_connect_object (_tmp20_, "global-engine-changed", (GCallback) __keyboard_input_method_page_page___lambda63__ibus_bus_global_engine_changed, self, 0);
	_tmp21_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp21_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	g_object_set ((GtkWidget*) _tmp21_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp21_);
	scroll = _tmp21_;
	_tmp22_ = scroll;
	_tmp23_ = self->priv->listbox;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = keyboard_input_method_page_add_engines_popover_new ();
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->add_engines_popover);
	self->priv->add_engines_popover = _tmp24_;
	_tmp25_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp25_);
	_tmp26_ = self->priv->add_engines_popover;
	_tmp27_ = _g_object_ref0 ((GtkPopover*) _tmp26_);
	_tmp28_ = g_strdup (_ ("Add…"));
	_tmp29_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp29_, (GtkWidget*) _tmp25_);
	_g_object_unref0 (_tmp25_);
	gtk_menu_button_set_popover (_tmp29_, _tmp27_);
	_g_object_unref0 (_tmp27_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _tmp28_);
	_g_free0 (_tmp28_);
	g_object_ref_sink (_tmp29_);
	add_button = _tmp29_;
	_tmp30_ = (GtkImage*) gtk_image_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp30_);
	_tmp31_ = g_strdup (_ ("Remove"));
	_tmp32_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp32_, (GtkWidget*) _tmp30_);
	_g_object_unref0 (_tmp30_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _tmp31_);
	_g_free0 (_tmp31_);
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->remove_button);
	self->priv->remove_button = _tmp32_;
	_tmp33_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp33_);
	actionbar = _tmp33_;
	_tmp34_ = actionbar;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp36_ = actionbar;
	_tmp37_ = add_button;
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
	_tmp38_ = actionbar;
	_tmp39_ = self->priv->remove_button;
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
	_tmp40_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp40_);
	left_grid = _tmp40_;
	_tmp41_ = left_grid;
	_tmp42_ = scroll;
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp42_, 0, 0, 1, 1);
	_tmp43_ = left_grid;
	_tmp44_ = actionbar;
	gtk_grid_attach (_tmp43_, (GtkWidget*) _tmp44_, 0, 1, 1, 1);
	_tmp45_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp45_);
	display = _tmp45_;
	_tmp46_ = display;
	_tmp47_ = left_grid;
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = (GtkLabel*) gtk_label_new (_ ("Switch engines:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp48_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp48_);
	keyboard_shortcut_label = _tmp48_;
	_tmp49_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp49_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp49_);
	_data15_->keyboard_shortcut_combobox = _tmp49_;
	_tmp50_ = _data15_->keyboard_shortcut_combobox;
	_tmp51_ = granite_accel_to_string ("<Alt>space");
	_tmp52_ = _tmp51_;
	gtk_combo_box_text_append (_tmp50_, "alt-space", _tmp52_);
	_g_free0 (_tmp52_);
	_tmp53_ = _data15_->keyboard_shortcut_combobox;
	_tmp54_ = granite_accel_to_string ("<Control>space");
	_tmp55_ = _tmp54_;
	gtk_combo_box_text_append (_tmp53_, "ctl-space", _tmp55_);
	_g_free0 (_tmp55_);
	_tmp56_ = _data15_->keyboard_shortcut_combobox;
	_tmp57_ = granite_accel_to_string ("<Shift>space");
	_tmp58_ = _tmp57_;
	gtk_combo_box_text_append (_tmp56_, "shift-space", _tmp58_);
	_g_free0 (_tmp58_);
	_tmp59_ = _data15_->keyboard_shortcut_combobox;
	_tmp60_ = keyboard_input_method_page_page_get_keyboard_shortcut (self);
	_tmp61_ = _tmp60_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp59_, _tmp61_);
	_g_free0 (_tmp61_);
	_tmp62_ = (GtkLabel*) gtk_label_new (_ ("Show property panel:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp62_);
	show_ibus_panel_label = _tmp62_;
	_tmp63_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp63_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp63_);
	show_ibus_panel_combobox = _tmp63_;
	_tmp64_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp64_, "none", _ ("Do not show"));
	_tmp65_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp65_, "auto-hide", _ ("Auto hide"));
	_tmp66_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp66_, "always-show", _ ("Always show"));
	_tmp67_ = (GtkLabel*) gtk_label_new (_ ("Embed preedit text in application window:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp67_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp67_);
	embed_preedit_text_label = _tmp67_;
	_tmp68_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp68_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp68_);
	embed_preedit_text_switch = _tmp68_;
	_tmp69_ = (GtkEntry*) gtk_entry_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp69_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp69_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp69_);
	_g_object_unref0 (self->priv->entry_test);
	self->priv->entry_test = _tmp69_;
	keyboard_input_method_page_page_update_entry_test_usable (self);
	_tmp70_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp70_, 12);
	gtk_widget_set_halign ((GtkWidget*) _tmp70_, GTK_ALIGN_CENTER);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp70_, TRUE);
	g_object_set ((GtkWidget*) _tmp70_, "margin", 12, NULL);
	gtk_grid_set_row_spacing (_tmp70_, 12);
	g_object_ref_sink (_tmp70_);
	right_grid = _tmp70_;
	_tmp71_ = right_grid;
	_tmp72_ = keyboard_shortcut_label;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 0, 1, 1);
	_tmp73_ = right_grid;
	_tmp74_ = _data15_->keyboard_shortcut_combobox;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 1, 0, 1, 1);
	_tmp75_ = right_grid;
	_tmp76_ = show_ibus_panel_label;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 0, 1, 1, 1);
	_tmp77_ = right_grid;
	_tmp78_ = show_ibus_panel_combobox;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 1, 1, 1, 1);
	_tmp79_ = right_grid;
	_tmp80_ = embed_preedit_text_label;
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 0, 2, 1, 1);
	_tmp81_ = right_grid;
	_tmp82_ = embed_preedit_text_switch;
	gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, 1, 2, 1, 1);
	_tmp83_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp83_, 12);
	gtk_grid_set_row_spacing (_tmp83_, 12);
	g_object_ref_sink (_tmp83_);
	main_grid = _tmp83_;
	_tmp84_ = main_grid;
	_tmp85_ = display;
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 0, 0, 1, 2);
	_tmp86_ = main_grid;
	_tmp87_ = right_grid;
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp87_, 1, 0, 1, 1);
	_tmp88_ = main_grid;
	_tmp89_ = self->priv->entry_test;
	gtk_grid_attach (_tmp88_, (GtkWidget*) _tmp89_, 1, 1, 1, 1);
	_tmp90_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp90_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp90_;
	_tmp91_ = self->priv->stack;
	_tmp92_ = no_daemon_runnning_alert;
	gtk_stack_add_named (_tmp91_, (GtkWidget*) _tmp92_, "no_daemon_runnning_view");
	_tmp93_ = self->priv->stack;
	_tmp94_ = self->priv->spawn_failed_alert;
	gtk_stack_add_named (_tmp93_, (GtkWidget*) _tmp94_, "spawn_failed_view");
	_tmp95_ = self->priv->stack;
	_tmp96_ = main_grid;
	gtk_stack_add_named (_tmp95_, (GtkWidget*) _tmp96_, "main_view");
	_tmp97_ = self->priv->stack;
	gtk_widget_show_all ((GtkWidget*) _tmp97_);
	gtk_widget_set_margin_start ((GtkWidget*) self, 12);
	gtk_widget_set_margin_end ((GtkWidget*) self, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
	_tmp98_ = self->priv->stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp98_);
	keyboard_input_method_page_page_set_visible_view (self, "");
	_tmp99_ = add_button;
	g_signal_connect_object ((GtkButton*) _tmp99_, "clicked", (GCallback) __keyboard_input_method_page_page___lambda64__gtk_button_clicked, self, 0);
	_tmp100_ = self->priv->add_engines_popover;
	g_signal_connect_object (_tmp100_, "add-engine", (GCallback) __keyboard_input_method_page_page___lambda65__keyboard_input_method_page_add_engines_popover_add_engine, self, 0);
	_tmp101_ = self->priv->remove_button;
	g_signal_connect_object ((GtkButton*) _tmp101_, "clicked", (GCallback) __keyboard_input_method_page_page___lambda66__gtk_button_clicked, self, 0);
	_tmp102_ = _data15_->keyboard_shortcut_combobox;
	g_signal_connect_data ((GtkComboBox*) _tmp102_, "changed", (GCallback) __keyboard_input_method_page_page___lambda67__gtk_combo_box_changed, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
	_tmp103_ = self->priv->ibus_panel_settings;
	_tmp104_ = show_ibus_panel_combobox;
	g_settings_bind (_tmp103_, "show", (GObject*) _tmp104_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp105_ = keyboard_plug_ibus_general_settings;
	_tmp106_ = embed_preedit_text_switch;
	g_settings_bind (_tmp105_, "embed-preedit-text", (GObject*) _tmp106_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp107_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp107_, "notify::active-index", (GCallback) __keyboard_input_method_page_page___lambda68__g_object_notify, self, 0);
	keyboard_input_method_page_page_update_list_box_selected_row (self);
	_g_object_unref0 (main_grid);
	_g_object_unref0 (right_grid);
	_g_object_unref0 (embed_preedit_text_switch);
	_g_object_unref0 (embed_preedit_text_label);
	_g_object_unref0 (show_ibus_panel_combobox);
	_g_object_unref0 (show_ibus_panel_label);
	_g_object_unref0 (keyboard_shortcut_label);
	_g_object_unref0 (display);
	_g_object_unref0 (left_grid);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (add_button);
	_g_object_unref0 (scroll);
	_g_object_unref0 (no_daemon_runnning_alert);
	_g_object_unref0 (keyboard_settings);
	block15_data_unref (_data15_);
	_data15_ = NULL;
	return obj;
}

static void
keyboard_input_method_page_page_class_init (KeyboardInputMethodPagePageClass * klass,
                                            gpointer klass_data)
{
	keyboard_input_method_page_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &KeyboardInputMethodPagePage_private_offset);
	G_OBJECT_CLASS (klass)->constructor = keyboard_input_method_page_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = keyboard_input_method_page_page_finalize;
}

static void
keyboard_input_method_page_page_instance_init (KeyboardInputMethodPagePage * self,
                                               gpointer klass)
{
	self->priv = keyboard_input_method_page_page_get_instance_private (self);
	self->priv->selection_changing = FALSE;
}

static void
keyboard_input_method_page_page_finalize (GObject * obj)
{
	KeyboardInputMethodPagePage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, KeyboardInputMethodPagePage);
	_g_object_unref0 (self->priv->bus);
	_g_object_unref0 (self->priv->ibus_panel_settings);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	_g_object_unref0 (self->priv->spawn_failed_alert);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->remove_button);
	_g_object_unref0 (self->priv->add_engines_popover);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->entry_test);
	G_OBJECT_CLASS (keyboard_input_method_page_page_parent_class)->finalize (obj);
}

static GType
keyboard_input_method_page_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardInputMethodPagePageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_input_method_page_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardInputMethodPagePage), 0, (GInstanceInitFunc) keyboard_input_method_page_page_instance_init, NULL };
	GType keyboard_input_method_page_page_type_id;
	keyboard_input_method_page_page_type_id = g_type_register_static (gtk_grid_get_type (), "KeyboardInputMethodPagePage", &g_define_type_info, 0);
	KeyboardInputMethodPagePage_private_offset = g_type_add_instance_private (keyboard_input_method_page_page_type_id, sizeof (KeyboardInputMethodPagePagePrivate));
	return keyboard_input_method_page_page_type_id;
}

GType
keyboard_input_method_page_page_get_type (void)
{
	static volatile gsize keyboard_input_method_page_page_type_id__once = 0;
	if (g_once_init_enter (&keyboard_input_method_page_page_type_id__once)) {
		GType keyboard_input_method_page_page_type_id;
		keyboard_input_method_page_page_type_id = keyboard_input_method_page_page_get_type_once ();
		g_once_init_leave (&keyboard_input_method_page_page_type_id__once, keyboard_input_method_page_page_type_id);
	}
	return keyboard_input_method_page_page_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

